<?php
class NotesController extends NoteAppController {
/**
 * Scaffold
 *
 * @var mixed
 */
   public $scaffold;
    public function index() {
        $this->set('notes', $this->Note->find('all'));
    }
    public function view($id = null) {
        if (!$id) {
            throw new NotFoundException(__d('Note', 'Invalid note'));
        }
        $note = $this->Note->findById($id);
        if (!$note) {
            throw new NotFoundException(__d('Note', 'Invalid note'));
        }
        
        MooCore::getInstance()->setSubject($note);
        $this->loadModel('Tag');
        $tags = $this->Tag->getContentTags($id, 'Note_Note');
        $this->set('tags', $tags);
        $this->set('note', $note);
    }
    public function add() {
        if ($this->request->is('post')) {
            $this->Note->create();
            $this->request->data['Note']['user_id'] = $this->Session->read('uid');
            if ($this->Note->save($this->request->data)) {
            	
            	$this->loadModel('Tag');
            	$this->Tag->saveTags($this->request->data['Note']['tags'], $this->Note->id, 'Note_Note');
            	
                $this->Session->setFlash(__d('Note', 'Your note has been saved.'));
                return $this->redirect(array('action' => 'index'));
            }
            $this->Session->setFlash(__d('Note', 'Unable to add your note.'));
        }
    }
    public function edit($id = null) {
        if (!$id) {
            throw new NotFoundException(__d('Note', 'Invalid note'));
        }
        $note = $this->Note->findById($id);
        if (!$note) {
            throw new NotFoundException(__d('Note', 'Invalid note'));
        }
        $this->loadModel('Tag');
        if ($this->request->is(array('post', 'put'))) {
            $this->Note->id = $id;
            $this->request->data['Note']['user_id'] = $this->Session->read('uid');
            if ($this->Note->save($this->request->data)) {
            	$this->Tag->saveTags($this->request->data['Note']['tags'], $id, 'Note_Note');
            	
                $this->Session->setFlash(__d('Note', 'Your note has been updated.'));
                return $this->redirect(array('action' => 'index'));
            }
            $this->Session->setFlash(__d('Note', 'Unable to update your note.'));
        }
        $tags = $this->Tag->getContentTags($id, 'Note_Note');
        $this->set('tags', $tags);
        
        if (!$this->request->data) {
            $this->request->data = $note;
        }
    }
    public function delete($id) {
        if (!$id) {
            throw new NotFoundException(__d('Note', 'Invalid note'));
        }
        if ($this->Note->delete($id)) {
            $this->Session->setFlash(
                __('The note with id: %s has been deleted.', h($id))
            );
            return $this->redirect(array('action' => 'index'));
        }
    }
    
    public function admin_index()
    {
    	$this->_checkPermission(array('super_admin' => 1));
    	$notes = $this->paginate('Note');
    	$this->set('notes', $notes);
    	
    	if ($this->request->is(array('post', 'put'))) {
    		$notes = $this->request->data['notes'];
    		if (count($notes))
    		{
    			foreach ($notes as $id)
    			{
    				$this->Note->delete($id);
    				$this->Session->setFlash( __d('Note','The selected notes have been deleted'),'default',
                            array('class' => 'Metronic-alerts alert alert-success fade in' ));
    			}
    		}
    		$this->redirect( $this->referer() );
    	}
    }
}