<?php
App::uses('NoteAppModel', 'Note.Model');
/**
 * Note Model
 *
 */
class Note extends NoteAppModel {
	public $mooFields = array('title','href','plugin','type','url');
	
	public $belongsTo = array( 'User' );
	
    public $validate = array(
        'title' => array(
            'rule' => 'notEmpty'
        ),
        'body' => array(
            'rule' => 'notEmpty'
        ),
        'reminder' => array(
        	'rule' => 'numeric',
            'message' => 'Only numbers allowed',
        )
    );
    
    public $actsAs = array(
        'Activity' => array(
            'type' => APP_USER,
            'action_afterCreated'=>'note_feed',
            'item_type'=>'Note_Note',
            'query'=>1,
            'params' => 'item'
        ),
    );
    
    public $hasMany = array( 'Comment' => array( 
											'className' => 'Comment',	
											'foreignKey' => 'target_id',
											'conditions' => array('Comment.type' => 'Note_Note'),						
											'dependent'=> true
										),
						  	 'Like' => array( 
											'className' => 'Like',	
											'foreignKey' => 'target_id',
											'conditions' => array('Like.type' => 'Note_Note'),						
											'dependent'=> true
										),
						  	 'Tag' => array( 
											'className' => 'Tag',	
											'foreignKey' => 'target_id',
											'conditions' => array('Tag.type' => 'Note_Note'),						
											'dependent'=> true
										)
						); 
    
	public function getHref($row)
    {
    	$request = Router::getRequest();
    	if (isset($row['id']))
    		return $request->base.'/notes/view/'.$row['id'];
    	else 
    		return '';
    }
    
    public function afterDeleteComment($data)
    {
    	$this->decreaseCounter($data['Comment']['target_id']);
    }
    
    public function afterComment($data,$uid)
    {
    	$this->increaseCounter($data['target_id']);
    }
    
    
}