<?php 
App::uses('MooPlugin','Lib');
class NotePlugin implements MooPlugin{
    public function install(){
    	$mailModel = MooCore::getInstance()->getModel('Mail_Mailtemplate');    	
    	$languageModel = MooCore::getInstance()->getModel('Language');
    	$langs = $languageModel->find('all');
    	$data['Mailtemplate'] = array(
    		'type' => 'note_reminder',
    		'plugin' => 'Note',
    		'vars' => '[note_name],[note_link]'
    	);
    	$mailModel->save($data);
    	$id = $mailModel->id;
    	foreach ($langs as $lang)
    	{
    		$language = $lang['Language']['key'];
    		$mailModel->locale = $language;
    		$data_translate['subject'] = 'Note reminder';
    		$content = <<<EOF
    <p>[header]</p>
    <p>This is mail reminder : <a href="[note_link]">[note_name]</a></p>
    <p>[footer]</p>    
EOF;
    		$data_translate['content'] = $content;
    		$mailModel->save($data_translate);
    	}
    }
    public function uninstall(){
    	$mailModel = MooCore::getInstance()->getModel('Mail_Mailtemplate');
    	$mailModel->deleteAll(array('Mailtemplate.type'=>'note_reminder'),true,true);
    }
    public function settingGuide(){}
    public function menu()
    {
        return array(
            'Notes Manage' => array('plugin' => 'note', 'controller' => 'notes', 'action' => 'admin_index'),
            'Settings' => array('plugin' => 'note', 'controller' => 'note_settings', 'action' => 'admin_index'),
        );
    }
    /*
    Example for version 1.0: This function will be executed when plugin is upgraded (Optional)
    public function callback_1_0(){}
    */
}