<?php 
App::import('Cron.Task','CronTaskAbstract');
class NoteTaskReminder extends CronTaskAbstract
{
    public function execute()
    {
    	$noteModel = MooCore::getInstance()->getModel('Note_Note');
    	$notes = $noteModel->find('all',array('conditions'=>array(
    		'check_reminder' => false,
    		'reminder >' => 0,
    		'(UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP(Note.created) > Note.reminder * 3600)'
    	)));
    	
    	if (count($notes))
    	{
    		$mailComponent = MooCore::getInstance()->getComponent('Mail.MooMail');
    		$ssl_mode = Configure::read('core.ssl_mode');
        	$http = (!empty($ssl_mode)) ? 'https' :  'http';
    		foreach ($notes as $note)
    		{
    			$mailComponent->send($note['Note']['user_id'],'note_reminder',
    				array(
    					'note_name' => $note['Note']['moo_title'],
    					'note_link' => $http.'://'.$_SERVER['SERVER_NAME'].$note['Note']['moo_href'],
    				)
    			);
    			
    			$noteModel->id = $note['Note']['id'];
    			$noteModel->save(array('check_reminder'=>true));
    		}
    	}
    }
}